function final_pos = my_impoly(init_pts, snap_lines, is_closed)
  % plot the lines
  if nargin<3
    is_closed = true;
  end
  hold on;
  for k=1:numel(snap_lines)
    plot( snap_lines{k}(:,1), snap_lines{k}(:,2), 'r-', 'LineWidth', 2 );
  end
  threshold = 20;
  old_pos = init_pts;
  s_down = false;
  lock = false;
  hold off;
  global h;
  h=impoly(gca, old_pos, 'PositionConstraintFcn', @fcn, 'closed', is_closed);
  key_down_id = iptaddcallback(gcf,'WindowKeyPressFcn',@sDown);
  key_up_id = iptaddcallback(gcf,'WindowKeyReleaseFcn',@sUp);
  final_pos = wait(h);
  delete(h);
  
  function sUp(h_fig,evt)
    if strcmp(evt.Key,'s')
        s_down = false;
    end
  end
  function sDown(h_fig,evt)
    if strcmp(evt.Key,'s');
        s_down = true;
    end
    if strcmp(evt.Key,'return')
      try
        h.resume();
      end
    end
  end

  function pos = fcn(pos)
    if s_down
      return;
    end
    if lock, return; end
    lock = true;
    % if it is adding a point
    if size(pos,1)>size(old_pos,1)
      old_pos = pos;
      lock = false;
      return;
    end
    
    % find the point that changed
    n=size(pos, 1);
    changed_id = false(n,1);
    if isempty(old_pos)
      old_pos = pos;
      lock = false;
      return;
    end
    for i=1:n
      if sum(abs(pos(i,1)-old_pos(:,1))<1e-4) && sum(abs(pos(i,2)-old_pos(:,2))<1e-4)
        continue;
      else
        changed_id(i) = true;
      end
    end
    % if more than one point changed, exit
    
    % if more than one point changed, exit
    new_pos = pos(changed_id, :);
    n = size(new_pos, 1);
    if size(new_pos, 1)~=1
      old_pos = pos;
      lock = false;
      return;
    end
    
    snap = old_pos(~changed_id, :);
    % find lines that snaps
    snap = [snap; cat(1,snap_lines{:})];
    for j=1:numel(snap_lines)
      v1 = [snap_lines{j}(1,1)-snap_lines{j}(2,1), snap_lines{j}(1,2)-snap_lines{j}(2,2)];
      v0 = [new_pos(1)-snap_lines{j}(2,1), new_pos(2)-snap_lines{j}(2,2)];
      if ( abs(v1(1)*v0(2) - v1(2) * v0(1)) / sqrt(dot(v1, v1)) )<threshold
        flag = new_pos(1)<(max(snap_lines{j}(1,1), snap_lines{j}(2,1))+threshold) ...
            && new_pos(1)>(min(snap_lines{j}(1,1), snap_lines{j}(2,1))-threshold) ...
            && new_pos(2)<(max(snap_lines{j}(1,2), snap_lines{j}(2,2))+threshold) ...
            && new_pos(2)>(min(snap_lines{j}(1,2), snap_lines{j}(2,2))-threshold);
        if flag
          new_pos = dot(v1,v0)./dot(v1,v1).*v1 + snap_lines{j}(2,:);
          pos(changed_id,:) = new_pos;
          old_pos = pos;
          break;
        end
      end
    end

    % find the point that snaps
    distx = abs(new_pos(1)-snap(:,1));
    disty = abs(new_pos(2)-snap(:,2));
    [v, id] = min(distx);
    if v<threshold
      new_pos(1)=snap(id,1);
    end
    [v, id] = min(disty);
    if v<threshold
      new_pos(2)=snap(id,2);
    end
%     if flag1 && flag2
%       keyboard;
%     end
    pos(changed_id,:) = new_pos;
    old_pos = pos;
    lock = false;
  end
end