function scenemodel_export(model, fn)
  try
    javaaddpath('pb_wrapper/wrapper/protobuf-java-2.4.1.jar');
    javaaddpath('pb_wrapper/wrapper/scene-annotation.jar');
    wrapper=org.example.SceneAnnotationRuiqi.SceneAnnotationRuiqi_pb_wrapper();
  catch exp0
    error('Failed to load wrapper');
  end

  jscene = savemodel(model, 'Scene');
  jdata = jscene.toByteString().toString('ISO-8859-1').getBytes('ISO-8859-1');
  
  if numel(fn)>3
    do_gz = false;
    if strcmp(fn(end-2:end), '.gz')
    	fn = fn(1:end-3);
    end
    fid=fopen(fn, 'w+');
    fwrite(fid, jdata, 'int8');
    fclose(fid);
    gzip(fn);
    delete(fn);
  else
    fid=fopen(fn, 'w+');
    fwrite(fid, jdata, 'int8');
    fclose(fid);
  end
  
  function r = savemodel(m, pb)
    if strcmp(pb, 'DOUBLE') || strcmp(pb, 'INT32')
      r = m;
      return;
    elseif strcmp(pb, 'STRING')
      r = java.lang.String(m);
      return;
    elseif strcmp(pb, 'Matrix')
      r = helper_tomatrix(m);
      return;
    elseif strcmp(pb, 'ExtensionField')
      value = m.value;
      key = m.key;
      if isa(m.value, 'double')
        t = helper_tomatrix(value);
        value = t.toByteString().toString('ISO-8859-1');
        key = ['Matrix:' m.key];
      end
      ja0 = wrapper.getExtensionFieldBuilder();
      ja0.setKey(key);
      ja0.setValue(java.lang.String(value));
      r = ja0.build();
      return;
    end
    
    ja = eval(['wrapper.get' pb 'Builder();']);
    allfields = ja.getDescriptor().getFields().toArray();
    for f=1:numel(allfields)
      f_name = char(allfields(f).getName());
      jf_name = f_name;
      jf_name(1) = upper( jf_name(1) );
      
      type_name = char(allfields(f).getType());
      if strcmp(type_name, 'MESSAGE')
        type_name = char(allfields(f).getMessageType().getName());
      end
        
      if allfields(f).isRepeated()
        if isfield(m, f_name)
          sm = getfield(m, f_name);
          for i=1:numel(sm)
            ja_child = savemodel(sm{i}, type_name);
            eval(['ja.add' jf_name '(ja_child);']);
          end
        end
      else
        if isfield(m, f_name)
          % using a subtyped model
          % type is set as .type field
          if strcmp(f_name, 'model')
            ja_child = savemodel(m.model, getfield(m, 'type'));
            ja_child = java.lang.String(ja_child.toByteString().toString('ISO-8859-1'));
          else
            sm = getfield(m, f_name);
            ja_child = savemodel(sm, type_name);
          end
          eval(['ja.set' jf_name '(ja_child);']);
        end
      end
    end
    r = ja.build();
  end
end

function mb = helper_tomatrix(x)
  wrapper=org.example.SceneAnnotationRuiqi.SceneAnnotationRuiqi_pb_wrapper();
  m = wrapper.getMatrixBuilder();
  if isempty(x)
    mb = m.build();
    return;
  end
  for i=1:numel(size(x))
    m.addDim(int32(size(x, i)));
  end
  wrapper.setMatrixData(m, x(:));
  mb = m.build();
end