function model = scenemodel_import(fn)
  try
    javaaddpath('pb_wrapper/wrapper/protobuf-java-2.4.1.jar');
    javaaddpath('pb_wrapper/wrapper/scene-annotation.jar');
    wrapper=org.example.SceneAnnotationRuiqi.SceneAnnotationRuiqi_pb_wrapper();
  catch exp0
    error('Failed to load wrapper');
  end
  if numel(fn)>=3
    if strcmp(fn(end-2:end), '.gz')
      try
        fn = gunzip(fn);
        fn = fn{1};
      catch exp0
        error('Unknown input type.');
      end
    end
  end
  
  model = struct;
  
  fid=fopen(fn);
  fdata = fread(fid, 'int8');
  fclose(fid);
  jscene = wrapper.getSceneBuilder();
  jscene = jscene.mergeFrom(fdata);
  jscene = jscene.build();
  
  model = loadmodel(jscene);
  function m = loadmodel(ja)
    if strcmp(class(ja), 'double')
      m = ja;
      return;
    elseif strcmp(class(ja), 'java.lang.String')
      m = char(ja);
      return;
    else
      type_name = char(ja.getDescriptor().getName());
      if strcmp(type_name, 'Matrix')
        m = helper_frommatrix(ja);
        return;
      elseif strcmp(type_name, 'ExtensionField')
        key = char(ja.getKey());
        m = struct;
        m.key = key;
        delim_pos = strfind(key, ':');
        value = [];
        if ~isempty(delim_pos)
          if strcmp(key(1:delim_pos-1), 'Matrix')
            m.value = [];
            return;
            try 
              mm = wrapper.getMatrixBuilder();
              value = ja.getValue().getBytes();
              mm.mergeFrom(value);
            catch exp1
              mm = wrapper.getMatrixBuilder();
              %value = ja.getValue().getBytes('ISO-8859-1');
              value = ja.getValue().getBytes('CP1252');
              mm.mergeFrom(value);
            end
            
            mm=mm.build();
            m.key = key((delim_pos+1):end);
            m.value = helper_frommatrix(mm);
            return;
          end
        end
        m.value = char(value);
        return;
      end
    end
    
    m = struct;
    allfields = ja.getDescriptor().getFields().toArray();
    for f=1:numel(allfields)
      f_name = char(allfields(f).getName());
      jf_name = f_name;
      jf_name(1) = upper( jf_name(1) );
      
      if allfields(f).isRepeated()
        len = eval(['ja.get' jf_name 'Count()']);
        for j=1:len
          sm = eval(['ja.get' jf_name '(' int2str(j-1) ');']);
          eval(['m.' f_name '{' int2str(j) '}=loadmodel(sm);']);
        end
      else
        if eval(['ja.has' jf_name '()'])
          sm = eval(['ja.get' jf_name '();']);
          if strcmp(f_name, 'model')
            type_name = char(eval(['ja.getType();']));
            
            try 
              mm = eval(['wrapper.get' type_name 'Builder()']);
              value = sm.getBytes();
              mm.mergeFrom(value);
            catch exp1
              mm = eval(['wrapper.get' type_name 'Builder()']);
              value = sm.getBytes('CP1252');
              %value = sm.getBytes('UTF-8');
              mm.mergeFrom(value);
            end
            sm=mm.build();
            eval(['m.' f_name '=loadmodel(sm);']);
          else
            eval(['m.' f_name '=loadmodel(sm);']);
          end
        end
      end
    end
  end
end

function x = helper_frommatrix(m)
  wrapper=org.example.SceneAnnotationRuiqi.SceneAnnotationRuiqi_pb_wrapper();
  x = wrapper.getMatrixData(m);
  
  dim = [];
  for i=1:m.getDimCount()
    dim = [dim m.getDim(i-1)];
  end
  
  if ~isempty(dim)
    x = reshape(x, dim);
  else
    x = [];
  end
end
