function model = scenemodel_initialize(data)
  
  % export K
  fx_rgb = 5.1885790117450188e+02;
  fy_rgb = 5.1946961112127485e+02;
  cx_rgb = 3.2558244941119034e+02;
  cy_rgb = 2.5373616633400465e+02;

  % 45:471, 41:601
  m = 2/(601-41);
  K = ...
    [fx_rgb*m        0       (-(41+601)/2+cx_rgb)*m;
          0   fy_rgb*m       (-(45+471)/2+cy_rgb)*m;
          0          0              1];
      
  model.camera.K = K;
  model.camera.R = data.R;
  model.camera.Origin.x = 0; model.camera.Origin.y = 0; model.camera.Origin.z = 0;
  model.data.coord = double(cat(3, data.X, data.Y, data.Z));
  model.data.image = im2double(data.images);
  model.data.info{1}.key = 'gt';
  model.data.info{1}.value = double(data.gt);
  model.data.info{2}.key = 'support';
  model.data.info{2}.value = double(data.support);
  model.data.info{3}.key = 'label_names';
  label_names = sprintf('%s,', data.label_names{:});
  label_names = label_names(1:end-1);
  model.data.info{3}.value = label_names;
  model.data.info{4}.key = 'scene';
  model.data.info{4}.value = data.scenes;
  model.data.info{5}.key = 'rawDepths';
  model.data.info{5}.value = double(data.rawDepths);
  model.objects = {};
end